<?php
 
 
 

namespace PhpWA\Protocol\Proto;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class EmbeddedMusic extends \Google\Protobuf\Internal\Message
{
    


    protected $musicContentMediaId = null;
    


    protected $songId = null;
    


    protected $author = null;
    


    protected $title = null;
    


    protected $artworkDirectPath = null;
    


    protected $artworkSha256 = null;
    


    protected $artworkEncSha256 = null;
    


    protected $artistAttribution = null;
    


    protected $countryBlocklist = null;
    


    protected $isExplicit = null;
    


    protected $artworkMediaKey = null;
    


    protected $musicSongStartTimeInMs = null;
    


    protected $derivedContentStartTimeInMs = null;
    


    protected $overlapDurationInMs = null;

    





















    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getMusicContentMediaId()
    {
        return isset($this->musicContentMediaId) ? $this->musicContentMediaId : '';
    }

    public function hasMusicContentMediaId()
    {
        return isset($this->musicContentMediaId);
    }

    public function clearMusicContentMediaId()
    {
        unset($this->musicContentMediaId);
    }

    




    public function setMusicContentMediaId($var)
    {
        GPBUtil::checkString($var, True);
        $this->musicContentMediaId = $var;

        return $this;
    }

    



    public function getSongId()
    {
        return isset($this->songId) ? $this->songId : '';
    }

    public function hasSongId()
    {
        return isset($this->songId);
    }

    public function clearSongId()
    {
        unset($this->songId);
    }

    




    public function setSongId($var)
    {
        GPBUtil::checkString($var, True);
        $this->songId = $var;

        return $this;
    }

    



    public function getAuthor()
    {
        return isset($this->author) ? $this->author : '';
    }

    public function hasAuthor()
    {
        return isset($this->author);
    }

    public function clearAuthor()
    {
        unset($this->author);
    }

    




    public function setAuthor($var)
    {
        GPBUtil::checkString($var, True);
        $this->author = $var;

        return $this;
    }

    



    public function getTitle()
    {
        return isset($this->title) ? $this->title : '';
    }

    public function hasTitle()
    {
        return isset($this->title);
    }

    public function clearTitle()
    {
        unset($this->title);
    }

    




    public function setTitle($var)
    {
        GPBUtil::checkString($var, True);
        $this->title = $var;

        return $this;
    }

    



    public function getArtworkDirectPath()
    {
        return isset($this->artworkDirectPath) ? $this->artworkDirectPath : '';
    }

    public function hasArtworkDirectPath()
    {
        return isset($this->artworkDirectPath);
    }

    public function clearArtworkDirectPath()
    {
        unset($this->artworkDirectPath);
    }

    




    public function setArtworkDirectPath($var)
    {
        GPBUtil::checkString($var, True);
        $this->artworkDirectPath = $var;

        return $this;
    }

    



    public function getArtworkSha256()
    {
        return isset($this->artworkSha256) ? $this->artworkSha256 : '';
    }

    public function hasArtworkSha256()
    {
        return isset($this->artworkSha256);
    }

    public function clearArtworkSha256()
    {
        unset($this->artworkSha256);
    }

    




    public function setArtworkSha256($var)
    {
        GPBUtil::checkString($var, False);
        $this->artworkSha256 = $var;

        return $this;
    }

    



    public function getArtworkEncSha256()
    {
        return isset($this->artworkEncSha256) ? $this->artworkEncSha256 : '';
    }

    public function hasArtworkEncSha256()
    {
        return isset($this->artworkEncSha256);
    }

    public function clearArtworkEncSha256()
    {
        unset($this->artworkEncSha256);
    }

    




    public function setArtworkEncSha256($var)
    {
        GPBUtil::checkString($var, False);
        $this->artworkEncSha256 = $var;

        return $this;
    }

    



    public function getArtistAttribution()
    {
        return isset($this->artistAttribution) ? $this->artistAttribution : '';
    }

    public function hasArtistAttribution()
    {
        return isset($this->artistAttribution);
    }

    public function clearArtistAttribution()
    {
        unset($this->artistAttribution);
    }

    




    public function setArtistAttribution($var)
    {
        GPBUtil::checkString($var, True);
        $this->artistAttribution = $var;

        return $this;
    }

    



    public function getCountryBlocklist()
    {
        return isset($this->countryBlocklist) ? $this->countryBlocklist : '';
    }

    public function hasCountryBlocklist()
    {
        return isset($this->countryBlocklist);
    }

    public function clearCountryBlocklist()
    {
        unset($this->countryBlocklist);
    }

    




    public function setCountryBlocklist($var)
    {
        GPBUtil::checkString($var, False);
        $this->countryBlocklist = $var;

        return $this;
    }

    



    public function getIsExplicit()
    {
        return isset($this->isExplicit) ? $this->isExplicit : false;
    }

    public function hasIsExplicit()
    {
        return isset($this->isExplicit);
    }

    public function clearIsExplicit()
    {
        unset($this->isExplicit);
    }

    




    public function setIsExplicit($var)
    {
        GPBUtil::checkBool($var);
        $this->isExplicit = $var;

        return $this;
    }

    



    public function getArtworkMediaKey()
    {
        return isset($this->artworkMediaKey) ? $this->artworkMediaKey : '';
    }

    public function hasArtworkMediaKey()
    {
        return isset($this->artworkMediaKey);
    }

    public function clearArtworkMediaKey()
    {
        unset($this->artworkMediaKey);
    }

    




    public function setArtworkMediaKey($var)
    {
        GPBUtil::checkString($var, False);
        $this->artworkMediaKey = $var;

        return $this;
    }

    



    public function getMusicSongStartTimeInMs()
    {
        return isset($this->musicSongStartTimeInMs) ? $this->musicSongStartTimeInMs : 0;
    }

    public function hasMusicSongStartTimeInMs()
    {
        return isset($this->musicSongStartTimeInMs);
    }

    public function clearMusicSongStartTimeInMs()
    {
        unset($this->musicSongStartTimeInMs);
    }

    




    public function setMusicSongStartTimeInMs($var)
    {
        GPBUtil::checkInt64($var);
        $this->musicSongStartTimeInMs = $var;

        return $this;
    }

    



    public function getDerivedContentStartTimeInMs()
    {
        return isset($this->derivedContentStartTimeInMs) ? $this->derivedContentStartTimeInMs : 0;
    }

    public function hasDerivedContentStartTimeInMs()
    {
        return isset($this->derivedContentStartTimeInMs);
    }

    public function clearDerivedContentStartTimeInMs()
    {
        unset($this->derivedContentStartTimeInMs);
    }

    




    public function setDerivedContentStartTimeInMs($var)
    {
        GPBUtil::checkInt64($var);
        $this->derivedContentStartTimeInMs = $var;

        return $this;
    }

    



    public function getOverlapDurationInMs()
    {
        return isset($this->overlapDurationInMs) ? $this->overlapDurationInMs : 0;
    }

    public function hasOverlapDurationInMs()
    {
        return isset($this->overlapDurationInMs);
    }

    public function clearOverlapDurationInMs()
    {
        unset($this->overlapDurationInMs);
    }

    




    public function setOverlapDurationInMs($var)
    {
        GPBUtil::checkInt64($var);
        $this->overlapDurationInMs = $var;

        return $this;
    }

}

